/*
 * Copyright (C) 2000-2005
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 * 
 */
package estella.lib;
import  estella.gui.*;

import  java.io.FileOutputStream;
import  java.io.File;
import  java.net.Socket;
import  java.lang.String;
import  java.util.StringTokenizer;
import  java.io.IOException;
import  java.lang.Thread;
import  java.net.Socket;
import  java.net.SocketTimeoutException;
import  java.io.FileNotFoundException;
import  java.io.IOException;
import  javax.swing.*; 

/**
* Servidor web simples
* @author Cesar Kallas - cesarkallas at gmx . net
* @since 04/12/2005
*/
public class ArquivoDownload implements Runnable
{
	private int porta, index, tamanho;
	private String nome, host;
	private Conexao conexao;
	private Constantes CON;
	private Log LOG;
		
	public ArquivoDownload(String nome, int tamanho, int index, String host, int porta)
	{
		this.porta = porta;
		this.nome = nome;
		this.index = index;
		this.host = host;
		this.tamanho = tamanho;
	}
	
  /**
    * Inicia um novo servico de escuta em uma porta
    */
  public void run()
  {
		LOG = new Log("Cliente_downloadArquivo");
		CON = new Constantes();

		conexao = new Conexao(host, porta);
		if(conexao.inicia()) {
			System.out.println("conectado");
			conexao.setTimeout(CON.SOCKET_TIMEOUT);
			String msg = new String("GET /get/" + index + "/" + nome + "/ HTTP/1.0" + "\r\n");
			conexao.envia(msg +
				"User-Agent: Estella/Gnutella/0.4" + "\r\n" +
				"Range: bytes=0-" + "\r\n" + 
				"Connection: Keep-Alive" + "\r\n" + 
				"\r\n" );
			
			String resposta = new String(conexao.recebe());
			if(resposta.indexOf("HTTP/1.0 200 OK") == -1) {
				LOG.falha(" falha ao realizar download servent(" + host + ") porta(" + porta + ") arquivo(" + nome + ") index(" + index + ")");
				return;
			}
			
			LOG.info("Iniciado download servent(" + host + ") porta(" + porta + ") arquivo(" + nome + ") index(" + index + ")\n");
			
			try {
				if(conexao.recebeArquivo(CON.REPOSITORIO, nome, tamanho)) {
					LOG.info(" download completo : " + CON.REPOSITORIO + "/" + nome);
					JOptionPane.showMessageDialog(null, "Download concluido!\n./" + CON.REPOSITORIO + "/" + nome);
				}
				Dados.download-=1;
				synchronized(JanelaPrincipal.labelTransferencias) {
					JanelaPrincipal.labelTransferencias.setText(Dados.download + "/" + Dados.upload);
				}
			}
			catch(Exception falhaDownload) {
				LOG.info(" falha ao realizar download do arquivo " + falhaDownload.getMessage());
			}
		}
  }
}
